# script to update example-creds packages with etc/examplecreds content
set -e

update_package() {
mkdir tmp2 && cd tmp2
tar xzf ../data.tar.gz
rm -rf etc
cp -r ../../etc .
tar czf ../data.tar.gz .
find etc > ../conffiles
cd ..
rm -rf tmp2
mkdir tmp2 && cd tmp2
tar xzf ../control.tar.gz 
mv ../conffiles .
tar czf ../control.tar.gz .
cd ..
rm -rf tmp2
}

rm -rf tmpxtreemos
mkdir tmpxtreemos
cd tmpxtreemos
# update deb
ar x /var/www/html/xtreemos-md/all/example-creds*.deb
update_package();
ar r /var/www/html/xtreemos-md/all/example-creds*.deb ./*
update_package();
# update ipk
ar x /var/www/html/feed-xtreemos/example-creds*.deb
ar r /var/www/html/feed-xtreemos/example-creds*.deb ./*
mkdir tmp2 && cd tmp2
tar xzf ../data.tar.gz
cd ..
rm -rf tmpextreemos

# update Packages.gz in xtreemos-md (Maemo Packages)

MD5SUM=`md5sum /var/www/html/xtreemos-md/all/example-creds*.deb |cut -d" " -f1`
SHA1SUM=`sha1sum /var/www/html/xtreemos-md/all/example-creds*.deb |cut -d" " -f1`
gunzip -c /var/www/html/xtreemos-md/Packages.gz |
./update_Packages.py xtreemos-md/all/example-creds_0.0.18-1_all.deb $MD5SUM $SHA1SUM 
cd /var/www/html
gzip -f xtreemos-md/Packages

Release=/var/www/html/xtreemos-md/Release
date --utc "+Date: %a, %d %b %Y %H:%m:%S UTC" > $Release
echo "MD5Sum:" >> $Release
MD5SUM=`md5sum /var/www/html/xtreemos-md/Packages.gz | cut -d" " -f1`
S=`wc -c /var/www/html/xtreemos-md/Packages.gz | cut -d" " -f1`
echo " $MD5SUM          $S Packages.gz" >> $Release
MD5SUM=`md5sum /var/www/html/xtreemos-md/Sources.gz | cut -d" " -f1`
S=`wc -c /var/www/html/xtreemos-md/Sources.gz| cut -d" " -f1`
echo " $MD5SUM          $S Sources.gz" >> $Release
echo "SHA1:" >> $Release
SHA1SUM=`sha1sum /var/www/html/xtreemos-md/Packages.gz | cut -d" " -f1`
S=`wc -c /var/www/html/xtreemos-md/Packages.gz | cut -d" " -f1`
echo " $SHA1SUM          $S Packages.gz" >> $Release
SHA1SUM=`sha1sum /var/www/html/xtreemos-md/Sources.gz | cut -d" " -f1`
S=`wc -c /var/www/html/xtreemos-md/Sources.gz | cut -d" " -f1`
echo " $SHA1SUM          $S Sources.gz" >> $Release

# update Packages.gz in feed-xtreemos (Angstrom Packages)
cd /var/www/html/feed-xtreemos
./create_feed.sh
