#!/bin/sh
#xsub.sh , XtreemOS XSub wrapper
NO_ARGS=0
E_OPTERROR=65
#We suppose xsub is in the path
XSUB=xsub

if [ $# -eq "$NO_ARGS" ] 
then
  echo "Usage: `basename $0` <executable> <parameters> -in <input> -out <output> -err <error>"
  exit $E_OPTERROR
fi

EXEC=""
IN=""
OUT=""
ERR=""
PARAMS=""
KEEP=0
JSDLOUT="temp.jsdl"
I=1;
while [ $# -gt 0 ]
do
case $1 in
  "-in" ) shift 1; IN=$1; I=2;;
  "-out" ) shift 1; OUT=$1; I=2;;
  "-err" ) shift 1; ERR=$1; I=2;;
  "-keep" ) shift 1; JSDLOUT=$1; KEEP=1; I=2;;
esac

if [ $I -eq 0 ]
then 
    PARAMS="$PARAMS $1"
fi

if [ ! -n "$EXEC" ] 
then 
  EXEC=$1
  I=0
fi

shift 1
done

#echo "EXEC $EXEC"
#echo "PARAM $PARAMS"
#echo "IN $IN"
#echo "OUT $OUT"
#echo "ERR $ERR"

echo "<?xml version=\"1.0\" encoding=\"UTF-8\"?>" > $JSDLOUT
echo "<JobDefinition xmlns=\"http://schemas.ggf.org/jsdl/2005/11/jsdl\">" >> $JSDLOUT
echo "	<JobDescription>"  >> $JSDLOUT
echo "		<JobIdentification>"  >> $JSDLOUT
echo "			<JobName>$EXEC</JobName>"  >> $JSDLOUT
echo "			<Description>Xtreemos JSDL automatically generated</Description>" >> $JSDLOUT
echo "			<JobProject>XtreemOS</JobProject>" >> $JSDLOUT
echo "		</JobIdentification>" >> $JSDLOUT
echo "		<Application>" >> $JSDLOUT
echo " 		<POSIXApplication xmlns=\"http://schemas.ggf.org/jsdl/2005/11/jsdl-posix\">" >> $JSDLOUT
echo "			<ApplicationName>$EXEC</ApplicationName>" >> $JSDLOUT
echo "			<Executable>$EXEC</Executable>" >> $JSDLOUT
for i in $PARAMS
do
  echo "			<Argument>${i}</Argument>" >> $JSDLOUT
done
if [ -n "$IN" ] 
then 
  echo "			<Input>$IN</Input>" >> $JSDLOUT
fi
if [ -n "$OUT" ]
then
  echo "			<Output>$OUT</Output>" >> $JSDLOUT
fi
if [ -n "$ERR" ]
then
  echo "			<Error>$ERR</Error>" >> $JSDLOUT
fi
echo "		</POSIXApplication>" >> $JSDLOUT
echo "		</Application>" >> $JSDLOUT
echo "		<Resources>" >> $JSDLOUT
echo " 			<TotalResourceCount>" >> $JSDLOUT
echo "			<Exact>1.0</Exact>" >> $JSDLOUT
echo "			</TotalResourceCount>" >> $JSDLOUT
#CPUArchitecture must be one of the valid from the jsdl list, but I don't know at that moment how to convert them
#echo "			<OperatingSystem>`uname`</OperatingSystem>" >> $JSDLOUT
#echo "			<CPUArchitecture>`grep "vendor_id" /proc/cpuinfo|awk 'BEGIN {FS=":"}{print  $2}'`</CPUArchitecture>" >> $JSDLOUT
#echo "			<IndividualCPUCount>`grep "vendor_id" /proc/cpuinfo|awk 'BEGIN {FS=":"}{$1==processor cpus++}END{print cpus}'`</IndividualCPUCount>" >> $JSDLOUT
echo "		</Resources>" >> $JSDLOUT
echo "	</JobDescription>" >> $JSDLOUT
echo "</JobDefinition>" >> $JSDLOUT

#cat $JSDLOUT
$XSUB -f $JSDLOUT


if [ $KEEP -eq 0 ]
then
    rm $JSDLOUT
fi

