#include "XATICATypes.h"
#ifdef __cplusplus
 extern "C" {
 #endif
	/**
	 * Connect to CDA server.
	 */
int connectToCDA(const char* __caHost,const char* __cdaCert, void* returnValue);


	/**
	 * This method authenticates user with CDA server. It implements CDAIS - Invocation Service
	 * of the CDA. 
	 * 
	 * @param caCDAServer address of CDA server
	 * @param caCert is CDA's public certificate
	 * @param keyPair is users private and public key generated by Utils
	 * @param voUserName user name of the user on the VO
	 * @param voUserPass password of the user
	 * @return client certificate (object) which we still need to write somewhere on disc.
	 */
int authenticateWithCDA(const char* __caCDAServer,const char* __caCert,const char* __voUserName,const char* __voUserPass, void* returnValue);


#ifdef __cplusplus 
 } 
 #endif 
