#include "XATICATypes.h"
#ifdef __cplusplus
 extern "C" {
 #endif
	/************************************ CHECKPOINT ******************************************/
		
	/** INITIAL CP CMD TYPED IN ON ANY MACHINE 
	 *  entry point for single/multi-job checkpointing - redirection to super job checkpointer grid node in the next step
	 *  first job detects job dependencies: 1. from jdsl listed dependencies [NOW], 2. queries dependency monitor service (based on connector) [LATER]
	 *  ATTENTION job manager/checkpointer of job (referenced by passed jobId) becomes SUPER JOB CHECKPOINTER => coordinate all other involved job checkpointer
	 * @author John Mehnert-Spahn 
	 * @param jobId
	 * @param signed XOSCertificate 
	 */ 

int checkpointJobInit(const char* __jobId,int __resolveJobDependencies,const char* __modeType,const char* __options,const char* __userCert );


	/** JOB CHECKPOINTER (JC)
	 * know job units
	 * mJUC entry (job-unit address and state ) 
	 * select appropriate kernel checkpointer
	 */

int returnFromJobLocking(const char* __jobId,const char* __initialJobId,const char* __jsdlFile,const char* __executable,const ArrayListCA __jobUnitAddresses,const CommunicationAddress __superJobCpAddr,const ArrayList __dependentJobs,const char* __strategy,const char* __options,const char* __mode,int __ret,const char* __userCert );


	/************************** RESTART *********************************
	 * 
	 * 
	 * 
	 * 
	 * 
	 ******************************************************************* /
	 
	/*
	 * put ip- and port-details into required format for further computation
	 * 
	 */

int restartJobInit(const char* __jobId,const char* __checkpointVersion,int __restartDependentJobs,const ArrayList __ip,const ArrayList __port,const char* __mode,const char* __userCert );




int prepResReallocation(const char* __jobId,const char* __checkpointVersion,int __restartDependentJobs,const char* __desiredRestartDestination,const char* __mode,const char* __userCert );


	/**BEST SERVICE! - used!
	 * FEATURE: find matching nodes by regarding kernel checkpointer and potential resource(PID,IPC) conflicts, 
	 * DRAWBACK: unknown number of repeatedly called 'getResources' (worst case: it will never stop => upper limit)
	 */

int matchUnitsBiggerNodesCB(const ArrayListCA __list );




int proceedWithRebuilding(const char* __jobId,const char* __initialJobId );




int proceedWithResumingRST(const char* __jobId,const char* __initialJobId );




int terminateSingleMultiJobRestart(const char* __jobId,const char* __initialJobId );


#ifdef __cplusplus 
 } 
 #endif 
